Package io.vertx.reactivex.core.streams

## Class Pipe<T>

- java.lang.Object
- - io.vertx.reactivex.core.streams.Pipe<T>

-     public class Pipe<T>
      extends Object

  Pipe data from a `ReadStream` to a `WriteStream` and performs flow control where necessary to prevent the write stream buffer from getting overfull.

  Instances of this class read items from a `ReadStream` and write them to a `WriteStream`. If data can be read faster than it can be written this could result in the write queue of the `WriteStream` growing without bound, eventually causing it to exhaust all available RAM.

  To prevent this, after each write, instances of this class check whether the write queue of the `WriteStream` is full, and if so, the `ReadStream` is paused, and a `drainHandler` is set on the `WriteStream`.

  When the `WriteStream` has processed half of its backlog, the `drainHandler` will be called, which results in the pump resuming the `ReadStream`.

  This class can be used to pipe from any `ReadStream` to any `WriteStream`, e.g. from an `HttpServerRequest` to an `AsyncFile`, or from `NetSocket` to a `WebSocket`.

  Please see the documentation for more information.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<Pipe>` | `__TYPE_ARG` |
    `io.vertx.lang.rx.TypeArg<T>` | `__typeArg_0` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Pipe​(Pipe delegate)` |
    `Pipe​(Object delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the pipe.
    `Pipe<T>` | `endOnComplete​(boolean end)` | Set to `true` to call `WriteStream.end()` when the source `ReadStream` completes, `false` otherwise.
    `Pipe<T>` | `endOnFailure​(boolean end)` | Set to `true` to call `WriteStream.end()` when the source `ReadStream` fails, `false` otherwise.
    `Pipe<T>` | `endOnSuccess​(boolean end)` | Set to `true` to call `WriteStream.end()` when the source `ReadStream` succeeds, `false` otherwise.
    `boolean` | `equals​(Object o)` |
    `Pipe` | `getDelegate()` |
    `int` | `hashCode()` |
    `static <T> Pipe<T>` | `newInstance​(Pipe arg)` |
    `static <T> Pipe<T>` | `newInstance​(Pipe arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T)` |
    `Completable` | `rxTo​(WriteStream<T> dst)` | Start to pipe the elements to the destination `WriteStream`.
    `Future<Void>` | `to​(WriteStream<T> dst)` | Start to pipe the elements to the destination `WriteStream`.
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<Pipe> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<T> __typeArg_0

  - ### Constructor Detail

    - #### Pipe

          public Pipe​(Pipe delegate)

    - #### Pipe

          public Pipe​(Object delegate,
                      io.vertx.lang.rx.TypeArg<T> typeArg_0)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public Pipe getDelegate()

    - #### endOnFailure

          public Pipe<T> endOnFailure​(boolean end)

      Set to `true` to call `WriteStream.end()` when the source `ReadStream` fails, `false` otherwise.
      Parameters:
        `end` - `true` to end the stream on a source `ReadStream` failure
      Returns:
        a reference to this, so the API can be used fluently

    - #### endOnSuccess

          public Pipe<T> endOnSuccess​(boolean end)

      Set to `true` to call `WriteStream.end()` when the source `ReadStream` succeeds, `false` otherwise.
      Parameters:
        `end` - `true` to end the stream on a source `ReadStream` success
      Returns:
        a reference to this, so the API can be used fluently

    - #### endOnComplete

          public Pipe<T> endOnComplete​(boolean end)

      Set to `true` to call `WriteStream.end()` when the source `ReadStream` completes, `false` otherwise.

      Calling this overwrites `endOnFailure(boolean)` and `endOnSuccess(boolean)`.

      Parameters:
        `end` - `true` to end the stream on a source `ReadStream` completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### to

          public Future<Void> to​(WriteStream<T> dst)

      Start to pipe the elements to the destination `WriteStream`.

      When the operation fails with a write error, the source stream is resumed.

      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the pipe operation completes

    - #### rxTo

          public Completable rxTo​(WriteStream<T> dst)

      Start to pipe the elements to the destination `WriteStream`.

      When the operation fails with a write error, the source stream is resumed.

      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the pipe operation completes

    - #### close

          public void close()

      Close the pipe.

      The streams handlers will be unset and the read stream resumed unless it is already ended.

    - #### newInstance

          public static <T> Pipe<T> newInstance​(Pipe arg)

    - #### newInstance

          public static <T> Pipe<T> newInstance​(Pipe arg,
                                                io.vertx.lang.rx.TypeArg<T> __typeArg_T)